/* 
 * SMTP processor for sslwrap
 *
 * Written by Rick Kaseguma
 * Copyright 1999 Rick Kaseguma
 * http://www.rickk.com/sslwrap/
 *
 * September 1, 1999
 *
 */

#ifndef _SMTP_H_
#define _SMTP_H_

#include <stdio.h>   /* FILE* */

#include /*OPENSSL*/"ssl.h"

typedef enum {
  SMTP_INIT = 0,
  SMTP_GOTBANNER,
  SMTP_GOTEHLO,
  SMTP_AUTHWAIT,
  SMTP_USERWAIT,
  SMTP_PASSWAIT,
  SMTP_DATA,
  SMTP_IGNORE
} CurState;

typedef struct {
  CurState  state;
  int       sockIn;
  int       sockOut;
  SSL       *pConn;
  int       serverIsESMTP;
  FILE      *debug;
  char      user[20];
} SmtpState;

int smtpInit(SmtpState *pState, int sockIn, int sockOut, SSL *pConn);
int smtpRun(SmtpState *pState, const char *pBuf, int bufLen);
int smtpTerm(SmtpState *pState);
int smtpSend(SmtpState *pState, const char *str);
int smtpDebug(SmtpState *pState, const char *fmt, ... );
int smtpDecodeBase64(const char *bufPtr, int bufLen, char *dstPtr);

#endif












